<?php

namespace WCPM\Classes\Admin;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

class Documentation
{
    protected $documentation_host;

    public function __construct()
    {
        $this->documentation_host = 'docs.sweetcode.co';
    }

    public function get_link($key = 'default'): string
    {
        $documentation_links = [
            'default'                                                            => [
                'default' => '/wgact/',
                'wcm'     => '/'],
            'script_blockers'                                                    => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=script-blocker-error#/script-blockers',
                'wcm'     => '/'],
            'google_analytics_universal_property'                                => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-analytics-property-id#/pixels/google-analytics',
                'wcm'     => '/'],
            'google_analytics_4_id'                                              => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-analytics-4-id#/pixels/google-analytics',
                'wcm'     => '/'],
            'google_ads_conversion_id'                                           => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-ads-configure-the-plugin#/pixels/google-ads?id=configure-the-plugin',
                'wcm'     => '/'],
            'google_ads_conversion_label'                                        => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-ads-configure-the_plugin#/pixels/google-ads?id=configure-the-plugin',
                'wcm'     => '/'],
            'google_optimize_container_id'                                       => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-optimize#/pixels/google-optimize',
                'wcm'     => '/'],
            'facebook_pixel_id'                                                  => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=facebook-pixel-id#/pixels/facebook',
                'wcm'     => '/'],
            'bing_uet_tag_id'                                                    => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=microsoft-advertising-uet-tag-id#/pixels/microsoft-advertising?id=setting-up-the-uet-tag',
                'wcm'     => '/'],
            'twitter_pixel_id'                                                   => [
                'default' => '/wgact/#/twitter',
                'wcm'     => '/'],
            'pinterest_pixel_id'                                                 => [
                'default' => '/wgact/#/pinterest',
                'wcm'     => '/'],
            'snapchat_pixel_id'                                                  => [
                'default' => '/wgact/#/snapchat',
                'wcm'     => '/'],
            'tiktok_pixel_id'                                                    => [
                'default' => '/wgact/#/tiktok',
                'wcm'     => '/'],
            'hotjar_site_id'                                                     => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=hotjar-site-id#/pixels/hotjar',
                'wcm'     => '/'],
            'google_gtag_deactivation'                                           => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=gtag-js#/faq?id=google-tag-assistant-reports-multiple-installations-of-global-site-tag-gtagjs-detected-what-shall-i-do',
                'wcm'     => '/'],
            'google_consent_mode'                                                => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-consent-mode#/consent-mgmt/google-consent-mode',
                'wcm'     => '/'],
            'google_consent_regions'                                             => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-consent-mode-regions#/consent-mgmt/google-consent-mode?id=regions',
                'wcm'     => '/'],
            'google_analytics_eec'                                               => [
                'default' => '/wgact/#/pixels/google-analytics?id=enhanced-e-commerce-funnel-setup',
                'wcm'     => '/'],
            'google_analytics_4_api_secret'                                      => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-analytics-4-api-secret#/pixels/google-analytics?id=ga4-api-secret',
                'wcm'     => '/'],
            'google_ads_enhanced_conversions'                                    => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-ads-enhanced-conversions#/pixels/google-ads?id=enhanced-conversions',
                'wcm'     => '/'],
            'google_ads_phone_conversion_number'                                 => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-ads-phone-conversion-number#/pixels/google-ads?id=phone-conversion-number',
                'wcm'     => '/'],
            'google_ads_phone_conversion_label'                                  => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=google-ads-phone-conversion-number#/pixels/google-ads?id=phone-conversion-number',
                'wcm'     => '/'],
            'explicit_consent_mode'                                              => [
                'default' => '/wgact/#/consent-mgmt/overview?id=explicit-consent-mode',
                'wcm'     => '/'],
            'facebook_capi_token'                                                => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=facebook-capi-token#/pixels/facebook?id=facebook-conversion-api-capi',
                'wcm'     => '/'],
            'facebook_capi_user_transparency_process_anonymous_hits'             => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=facebook-capi-transparency-settings#/pixels/facebook?id=user-transparency-settings',
                'wcm'     => '/'],
            'facebook_capi_user_transparency_send_additional_client_identifiers' => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=facebook-capi-transparency-settings#/pixels/facebook?id=user-transparency-settings',
                'wcm'     => '/'],
            'facebook_microdata'                                                 => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=facebook-microdata#/pixels/facebook?id=microdata-tags-for-catalogues',
                'wcm'     => '/'],
            'maximum_compatibility_mode'                                         => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=maximum-compatibility-mode#/general?id=maximum-compatibility-mode',
                'wcm'     => '/'],
            'google_ads_dynamic_remarketing'                                     => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=dynamic-remarketing#/dynamic-remarketing',
                'wcm'     => '/'],
            'variations_output'                                                  => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=dynamic-remarketing#/dynamic-remarketing',
                'wcm'     => '/'],
            'aw_merchant_id'                                                     => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=conversion-cart-data#/pixels/google-ads?id=conversion-cart-data',
                'wcm'     => '/'],
            'custom_thank_you'                                                   => [
                'default' => '/wgact/#/troubleshooting?id=wc-custom-thank-you',
                'wcm'     => '/'],
            'the_dismiss_button_doesnt_work_why'                                 => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=wpp-pixel-manager-docs&utm_content=dismiss-button-info#/faq?id=the-dismiss-button-doesnt-work-why',
                'wcm'     => '/'],
            'wp-rocket-javascript-concatenation'                                 => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=wp-rocket-javascript-concatenation-error#/troubleshooting?id=wp-rocket-javascript-concatenation',
                'wcm'     => '/'],
            'litespeed-cache-inline-javascript-after-dom-ready'                  => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=litespeed-inline-js-dom-ready-error#/troubleshooting?id=litespeed-cache-inline-javascript-after-dom-ready',
                'wcm'     => '/'],
            'payment-gateways'                                                   => [
                'default' => '/wgact/?utm_source=woocommerce-plugin&utm_medium=documentation-link&utm_campaign=woocommerce-pixel-manager-docs&utm_content=paypal-standard-warning#/requirements?id=payment-gateways',
                'wcm'     => '/'],
            'test_order'                                                         => [
                'default' => '/wgact/#/test-order',
                'wcm'     => '/'],
        ];

        if (array_key_exists($key, $documentation_links)) {
            return $this->get_host() . $documentation_links[$key]['default'];
        } else {
            error_log('wpm documentation key "' . $key . '" not available');
            return $this->get_host() . $documentation_links['default'];
        }
    }

    private function get_host(): string
    {
        return 'https://' . $this->documentation_host;
    }
}