<?php

namespace WCPM\Classes\Pixels\Hotjar;

use WCPM\Classes\Pixels\Pixel;
use WCPM\Classes\Pixels\Trait_Shop;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

class Hotjar_Pixel extends Pixel
{
    use Trait_Shop;

    public function __construct($options)
    {
        parent::__construct($options);
    }

    public function inject_everywhere()
    {
        // @formatter:off

        echo "\n\t\t" . $this->get_formatted_script_tag([
                'async'           => false,
                'defer'           => false,
                'src'             => '',
                'cookie_category' => 'analytics',
                'pixel_name'      => 'hotjar',
                'inject_cfasync'  => false,

            ]) . PHP_EOL;
        ?>

            (function(h,o,t,j,a,r){
                h.hj=h.hj||function(){(h.hj.q=h.hj.q||[]).push(arguments)};
                h._hjSettings={hjid:<?php echo $this->options_obj->hotjar->site_id ?>,hjsv:6};
                a=o.getElementsByTagName('head')[0];
                r=o.createElement('script');r.async=1;
                r.src=t+h._hjSettings.hjid+j+h._hjSettings.hjsv;
                a.appendChild(r);
            })(window,document,'https://static.hotjar.com/c/hotjar-','.js?sv=');
        </script>
        <?php
        // @formatter:on
    }
}